| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | List of all members
cv::ximgproc::SuperpixelLSC Class Referenceabstract
Extended Image Processing » Superpixels

Class implementing the LSC (Linear Spectral Clustering) superpixels algorithm described in [161]. More...

`#include <opencv2/ximgproc/lsc.hpp>`

Collaboration diagram for cv::ximgproc::SuperpixelLSC:

## Public Member Functions
virtual void | enforceLabelConnectivity (int min_element_size=25)=0
| Enforce label connectivity.
virtual void | getLabelContourMask (OutputArray image, bool thick_line=true) const =0
| Returns the mask of the superpixel segmentation stored in SuperpixelLSC object.
virtual void | getLabels (OutputArray labels_out) const =0
| Returns the segmentation labeling of the image.
virtual int | getNumberOfSuperpixels () const =0
| Calculates the actual amount of superpixels on a given segmentation computed and stored in SuperpixelLSC object.
virtual void | iterate (int num_iterations=10)=0
| Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelLSC object.
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read.
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage.
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing the LSC (Linear Spectral Clustering) superpixels algorithm described in [161].

LSC (Linear Spectral Clustering) produces compact and uniform superpixels with low computational costs. Basically, a normalized cuts formulation of the superpixel segmentation is adopted based on a similarity metric that measures the color similarity and space proximity between image pixels. LSC is of linear computational complexity and high memory efficiency and is able to preserve global properties of images

## Member Function Documentation

## ◆ enforceLabelConnectivity()

virtual void cv::ximgproc::SuperpixelLSC::enforceLabelConnectivity | ( | int | min_element_size = 25 | ) |
| pure virtual

Python:
| cv.ximgproc.SuperpixelLSC.enforceLabelConnectivity( | [, min_element_size] | ) -> | None

Enforce label connectivity.

Parameters

  min_element_size | The minimum element size in percents that should be absorbed into a bigger superpixel. Given resulted average superpixel size valid value should be in 0-100 range, 25 means that less then a quarter sized superpixel should be absorbed, this is default.

The function merge component that is too small, assigning the previously found adjacent label to this component. Calling this function may change the final number of superpixels.

## ◆ getLabelContourMask()

virtual void cv::ximgproc::SuperpixelLSC::getLabelContourMask | ( | OutputArray | image,
|  | bool | thick_line = true ) const
| pure virtual

Python:
| cv.ximgproc.SuperpixelLSC.getLabelContourMask( | [, image[, thick_line]] | ) -> | image

Returns the mask of the superpixel segmentation stored in SuperpixelLSC object.

Parameters

  image | Return: CV_8U1 image mask where -1 indicates that the pixel is a superpixel border, and 0 otherwise.
  thick_line | If false, the border is only one pixel wide, otherwise all pixels at the border are masked.

The function return the boundaries of the superpixel segmentation.

## ◆ getLabels()

virtual void cv::ximgproc::SuperpixelLSC::getLabels | ( | OutputArray | labels_out | ) | const
| pure virtual

Python:
| cv.ximgproc.SuperpixelLSC.getLabels( | [, labels_out] | ) -> | labels_out

Returns the segmentation labeling of the image.

Each label represents a superpixel, and each pixel is assigned to one superpixel label.

Parameters

  labels_out | Return: A CV_32SC1 integer array containing the labels of the superpixel segmentation. The labels are in the range [0, getNumberOfSuperpixels()].

The function returns an image with the labels of the superpixel segmentation. The labels are in the range [0, getNumberOfSuperpixels()].

## ◆ getNumberOfSuperpixels()

virtual int cv::ximgproc::SuperpixelLSC::getNumberOfSuperpixels | ( |  | ) | const
| pure virtual

Python:
| cv.ximgproc.SuperpixelLSC.getNumberOfSuperpixels( |  | ) -> | retval

Calculates the actual amount of superpixels on a given segmentation computed and stored in SuperpixelLSC object.

## ◆ iterate()

virtual void cv::ximgproc::SuperpixelLSC::iterate | ( | int | num_iterations = 10 | ) |
| pure virtual

Python:
| cv.ximgproc.SuperpixelLSC.iterate( | [, num_iterations] | ) -> | None

Calculates the superpixel segmentation on a given image with the initialized parameters in the SuperpixelLSC object.

This function can be called again without the need of initializing the algorithm with createSuperpixelLSC(). This save the computational cost of allocating memory for all the structures of the algorithm.

Parameters

  num_iterations | Number of iterations. Higher number improves the result.

The function computes the superpixels segmentation of an image with the parameters initialized with the function createSuperpixelLSC(). The algorithms starts from a grid of superpixels and then refines the boundaries by proposing updates of edges boundaries.

The documentation for this class was generated from the following file:

- opencv2/ximgproc/lsc.hpp